from operator import delitem
from pyspark import SparkContext, SparkConf
import csv
import StringIO
from datetime import datetime, date

conf = SparkConf().setMaster('local').setAppName('utakmice')
sc = SparkContext(conf=conf)

def getRDDFromCSV(file):
    return sc.textFile(file).mapPartitions(lambda x: csv.reader(x)).map(lambda x: x[0].split(";"))

def format(x):
    yearFrom = datetime.strptime(x[1][1], "%d.%M.%Y").date().year
    yearTo = datetime.strptime(x[1][2], "%d.%M.%Y").date().year
    return (x[0], (x[1][0], yearFrom, yearTo))

def spread(x):
    yearFrom = x[1][1][1]
    yearTo = x[1][1][2]
    year = yearFrom
    i=1
    res = []
    while year is not yearTo:
        res.append(year)
        year += 1
    return res

utakmice = getRDDFromCSV("utakmice.csv").persist().map(lambda x: (x[1],x[0],  (x[2], x[3]))) #idSezone, idDomacina, idGosta
igraci = getRDDFromCSV("igraci.csv")
sezona = getRDDFromCSV("sezona.csv")
ugovori = getRDDFromCSV("ugovori.csv").map(lambda x: (x[2], (x[1], x[3], x[4]))).map(format) #idIgraca, idTima, datum1..2
golovi = getRDDFromCSV("golovi.csv").map(lambda x: (x[1], (x[3]))) #idUtkmice, (idIgraca, idTima)

igraci = igraci.join(ugovori).map(spread)
utakmice = utakmice.join(sezona).map(lambda x: (x[1][0], (x[1][1]))).join(golovi)

#godina ((domacin, gost))
print(utakmice.collect())
print(igraci.collect())