from pyspark import SparkConf,SparkContext

import csv

def getRDDFromCSV(file):
    return sc.textFile(file).mapPartitions(lambda x: csv.reader(x)).map(lambda x: x[0].split(";"))


conf=SparkConf().setMaster("local").setAppName("pokreni")
sc = SparkContext(conf=conf)


igraci = getRDDFromCSV("igraci.csv").map(lambda x : (x[0],x[1]))

#utakmice sa kljucom id sezone
utakmice=getRDDFromCSV("utakmice.csv").map(lambda x : (x[1],x[0]))

sezone=getRDDFromCSV("sezona.csv").map(lambda x : (x[0],x[1]))

#golovi sa kljucem id utakmice
golovi=getRDDFromCSV("golovi.csv").map(lambda x : (x[1],(x[0],x[2],x[3])))

sezonaUtakmica= sezone.join(utakmice).map(lambda x : (x[1][1],(x[0],x[1][0])))

#('2', (('1', '2018'), ('4', '1', '7')))


# lista id-eva igraca i svaki gol koji su postigli(pamti se samo sezona u kom je postignut gol)
SUG = sezonaUtakmica.join(golovi).map(lambda x: (x[1][1][2],x[1][0]))


#('1', ('Nemanja Matic', ('1', '2018')))

#kao i iznad,spojeno sa igracima da dobijem imena igraca.
igraciGolovi = igraci.join(SUG)


#(('1', ('Nemanja Matic', ('1', '2018'))), 1)

#sve ubaceno kao id da bih prebrojao po kljucu
igraciGolovi1= igraciGolovi.map(lambda x : (x,1) )


#(('1', ('Nemanja Matic', ('1', '2018'))), 2)
#dobio sam za svakog igraca i sezonu koliko je golova dao
goloviIgraca = igraciGolovi1.reduceByKey(lambda x,y : x+y)

goloviIgraca1 = goloviIgraca.map(lambda x: (x[0][0],(x[0][1][1][0],x[1])))

print(goloviIgraca1.collect())

goloviIgraca1.saveAsTextFile("golovi")


