from pyspark import SparkContext, SparkConf
import csv

conf = SparkConf().setMaster("local").setAppName("Utakmice")
sc = SparkContext(conf = conf)

def getRDDfromCSV(filename):
    return sc.textFile(filename).mapPartitions(lambda x:csv.reader(x))

utakmice = getRDDfromCSV("../utakmice.csv").map(lambda x: (x[0], x[1]))
igraci = getRDDfromCSV("../igraci.csv")
golovi = getRDDfromCSV("../golovi.csv").map(lambda x: (x[1], x[3]))
sezone = getRDDfromCSV("../sezone.csv")

golovi_po_utakmicama = golovi.join(utakmice)
utakmice_sa_sezonama = utakmice.map(lambda x: (x[1],x[0])).join(sezone)

golovi_po_sezonama = golovi_po_utakmicama.join(utakmice_sa_sezonama)

igraci_sa_golovima_po_sezonama = igraci.join(golovi_po_sezonama.map(lambda x: (x[0], x[1], x[2], x[3])))

maksGolova = 0
for line in igraci_sa_golovima_po_sezonama.collect():
    if line[1]>maksGolova:
        maksGolova= line[1]

with open ("najboljiStrelciPoSezoni.csv", "w") as f:
    for line in igraci_sa_golovima_po_sezonama.collect():
        f.write(line[0]+","+line[1]+str(line[2])+"\n")