from pyspark import SparkConf, SparkContext
import csv
import StringIO

conf = SparkConf().setMaster("local").setAppName("Utakmice")
sc = SparkContext(conf=conf)

def getRDDFromCsv(fileName):
	 return sc.textFile(fileName).mapPartitions(lambda x: csv.reader(x)).map(lambda x: x[0].split(";"))

#idIgraca, ime
igraci = getRDDFromCsv("igraci.csv").map(lambda x: (x[0], x[1]))
golovi = getRDDFromCsv("golovi.csv").map(lambda x: (x[0], (x[1], x[2], x[3])))

#idSezone, IdUtakmice, domacina, gosti
utakmice = getRDDFromCsv("utakmice.csv").map(lambda x: (x[1], (x[0], x[2], x[3])))
#idSezone, godina
sezona = getRDDFromCsv("sezona.csv").map(lambda x: (x[0], x[1]))
# idtime, idIgraca, dat1, datu2
ugovori = getRDDFromCsv("ugovori.csv").map(lambda x: (x[1], (x[2], x[3], x[4])))

#idUtakmice, (godia, domaci, gosti)
utakmicePoSezoni = sezona.join(utakmice).map(lambda x: (x[1][1][0], (x[1][0], x[1][1][1], x[1][1][2])))

#idTime, (idUtakmice, godina)
domaci = utakmicePoSezoni.map(lambda x: (x[1][1], (x[0], x[1][0]))) )
gosti = utakmicePoSezoni.map(lambda x: (x[1][2], (x[0], x[1][0]))) )

timovi = gosti.union(domaci)

# idTima, ((idUtak, godi), (IdIgraca, dat1, dat2))
timoviSaUgovorima = timovi.join(ugovori).filter(lambda x: (x[1][0][1] >= x[1][1][1] and  x[1][0][1] <= x[1][1][2]))

#idIgraca, (idTima, idUtakmice)
timoviSaUgovorima = timoviSaUgovorima.map(lambda x: (x[1][1][0], (x[0], x[1][0][0]))

najvise = timoviSaUgovorima.map(lambda x: (x[0], 1)).reduceByKey(lambda x, y: x+y)
najvise = najvise.map(lambda x: x[1]).max()

igraciSaNajvise = timoviSaUgovorima.filter(lambda x: x[0] == najvise)

podaciOIgracu = igraciSaNajvise.join(igraci)

print(podaciOIgracu.collect())

with open("najviseTitula.csv") as f:
	for line in podaciOIgracu.collect():
		f.write(line[0] + "," + line[1] + "\n");
