from pyspark import SparkContext,SparkConf
import csv
from datetime import datetime,date


conf = SparkConf().setMaster("local").setAppName("appname")
sc = SparkContext(conf = conf)
sc.setLogLevel("ERROR")

def getRDDFromCSV(file):
    return sc.textFile(file).mapPartitions(lambda x: csv.reader(x)).map(lambda x: x[0].split(";"))


def deff(x):
    print(x[0][0])
    print(x[0][1])
    print(x[1])
    print("")


utakmice = getRDDFromCSV("utakmice.csv").map(lambda x: (x[0], x[1])).partitionBy(4).persist()
print()
print(utakmice.collect())


golovi = getRDDFromCSV("golovi.csv").map(lambda x: (x[1], x[3])).partitionBy(4).persist()
print("")
print(utakmice.collect())


join1 = utakmice.join(golovi)
print("")
print(join1.collect())


novi = join1.map(lambda x:((x[1][0],x[1][1]),1))
print()
print(novi.collect())




#spojeni svi strelci po sezonama
reduce = novi.reduceByKey(lambda x,y:x[1][0]+y[1][0])
print("")
print(reduce.collect())


sezona1 = reduce.filter(lambda x:x[0][0]==1)
sezona2 = reduce.filter(lambda x:x[0][0]==2)

max1=0
max2=0

for line in sezona1.collect():
    if(line[1]>max1):
        max1=line[1]

for line in sezona2.collect():
    if(line[1]>max2):
        max2=line[1]



def maks(x,max):
    if(x[1]==max):
        return True
    else:
        return False


najbolji1 = sezona1.filter(lambda x:maks(x,max1))
najbolji2 = sezona2.filter(lambda x:maks(x,max2))

najbolji1 = najbolji1.map(lambda x:(x[0][1],1))
najbolji2 = najbolji2.map(lambda x:(x[0][1],1))

igraci = getRDDFromCSV("igraci.csv").map(lambda x: (x[0], x[1])).partitionBy(4).persist()

rezultat1 = igraci.join(najbolji1)
rezultat2 = igraci.join(najbolji2)


print("Za sezonu 1")
print(rezultat1.collect())


print("Za sezonu 2")
print(rezultat2.collect())







