from pyspark import *

import csv

conf = SparkConf().setMaster("local").setAppName("Utakmice")
sc = SparkContext(conf = conf)

def getRDDFromCSV(file):
    return sc.textFile(file).mapPartitions(lambda x: csv.reader(x)).map(lambda x: x[0].split(";"))


def viseGolova(row1, row2):
    if(int(row1[1]) >= int(row2[1])):
        return row1
    if(int(row2[1]) > int(row1[1])):
        return row2


#                                                
_igraci = getRDDFromCSV("igraci.csv").map(lambda x: (x[0], x[1]))

#                                                Sezona - Godina
_sezone = getRDDFromCSV("sezona.csv").map(lambda x: (x[0], x[1]))

#                                                  Sezona - Utakmica
_utk = getRDDFromCSV("utakmice.csv").map(lambda x: (x[1], x[0]))

#                                                   Utakmica - Igrac
_golovi = getRDDFromCSV("golovi.csv").map(lambda x: (x[1], x[3]))




#                                            Utakmica - Godina
utakmice = _utk.join(_sezone).map(lambda x: (x[1][0], x[1][1]))

#                                                    Igrac - Godina
goloviSezona = _golovi.join(utakmice).map(lambda x: (x[1][0], x[1][1]))

#                                                                           Igrac - Godina - BrojGolova
brojGolovaIgracaPoSezoni = goloviSezona.map(lambda x: ((x[0],x[1]), 1)).reduceByKey(lambda x, y: x + y)

#                                             Godina - Igrac, BrojGolova
pom = brojGolovaIgracaPoSezoni.map(lambda x: (x[0][1], [x[0][0], x[1]]))

rez = pom.reduceByKey(lambda x, y: viseGolova(x, y))

rezultat = rez.map(lambda x: (x[1][0], x[1][1])).join(_igraci).map(lambda x: [x[1][1], x[1][0]])

print("\n")
print("\n")

print("Rezultat:\n")

print(rezultat.collect())

print("\n")
print("\n")