from pyspark import SparkConf, SparkContext
import datetime

conf = SparkConf().setMaster("local").setAppName("kolokvijum")
sc = SparkContext(conf=conf)

import csv
def getRDDFromCSV(file):
    return sc.textFile(file).mapPartitions(lambda x: csv.reader(x)).map(lambda x: x[0].split(";"))

#(id, godina)
sezone = getRDDFromCSV("sezona.csv").map(lambda x: ((x[0]), x[1]))

#(id, name)
igraci = getRDDFromCSV("igraci.csv").map(lambda x: (x[0], x[1]))

#(idSezone, idUtakmice, idDomacina, idGosta)
utakmice = getRDDFromCSV("utakmice.csv").map(lambda x: ((x[1]), x[0], x[2], x[3]))

#(id, idUtakmice, idTima, idIgraca)
golovi = getRDDFromCSV("golovi.csv").map(lambda x: ((x[1]), x[0], x[2], x[3]))

#(id, ime)
timovi = getRDDFromCSV("timovi.csv").map(lambda x: (x[0], x[1]))

#(id, idTima, idIgraca, datum1, datum2)
ugovori = getRDDFromCSV("ugovori.csv").map(lambda x: (x[0], x[1], x[2], x[3], x[4]))

SezoneUtakmice = utakmice.join(sezone).map(lambda x: (x[1][0], x[0][0], x[1][1]))

Rdd = SezoneUtakmice.join(golovi).map(lambda x: )

print(Rdd.collect())

#spark-submit pokreni.py

