from pyspark import SparkContext, SparkConf
import csv
import StringIO
from datetime import date,datetime

conf = SparkConf().setMaster("local").setAppName("My App")
sc = SparkContext(conf = conf)

def loadRecord(line):
  """Parse a CSV line"""
  input = StringIO.StringIO(line)
  reader = csv.reader(input)
  data = reader.next()
  return data

def nadjiNajboljegUSezoni(x):

    d = dict()
    for k,v in x:
        if (d.get(k) == None):
            d[k] = v
        else:
            d[k] +=v 
    maxGolova = 0
    maxStrelac = None
    for k,v in d.items():
        if (v > maxGolova):
            maxGolova = v 
            maxStrelac = k 


    return (maxStrelac, maxGolova)

sezone = sc.textFile('sezona.csv').map(loadRecord).map(lambda x: (x[0].split(";")[0], x[0].split(";")[1])).partitionBy(4).persist()
golovi = sc.textFile('golovi.csv').map(loadRecord).map(lambda x: (x[0].split(";")[1], [x[0].split(";")[2], x[0].split(";")[3]])).partitionBy(4).persist()
utakmice = sc.textFile('utakmice.csv').map(loadRecord).map(lambda x: (x[0].split(";")[1], (x[0].split(";")[0], x[0].split(";")[2], x[0].split(";")[3]))).partitionBy(4).persist()

utakmice = utakmice.join(sezone).map(lambda x: (x[1][0][0], [x[1][1], x[1][0][1], x[1][0][2]]))
goloviPoSezoni = golovi.join(utakmice).map(lambda x: (x[1][1][0], (x[1][0][1], 1))).groupByKey().mapValues(list)

najboljiPoSezoni = goloviPoSezoni.mapValues(nadjiNajboljegUSezoni)

igraci = najboljiPoSezoni.map(lambda x: (x[1][0], x[0])).groupByKey().mapValues(list).map(lambda x: (x[0], len(x[1])))

maxTitula = 0
maxStrelac = None
for igrac, brTitula in igraci.collect():
    if (brTitula > maxTitula):
        maxTitula = brTitula 
        maxStrelac = igrac

print(maxStrelac, maxTitula)

sc.parallelize([maxStrelac, maxTitula]).saveAsTextFile('izlaz')






