from pyspark import SparkConf, SparkContext
import csv
from datetime import datetime


conf = SparkConf().setMaster('local').setAppName('sport')
sc = SparkContext(conf=conf)

def conv(x):
	try:
		return int(x)
	except:
		return str(x)

igraci = sc.textFile("igraci.csv").map(lambda x: x.split(';'))
igraci = igraci.map(lambda arr: [conv(x) for x in arr])
igraci = igraci.map(lambda y: (y[0], y[1]))
print(igraci.collect())

golovi = sc.textFile("golovi.csv").map(lambda x: x.split(';'))
golovi = golovi.map(lambda arr: [conv(x) for x in arr])
golovi = golovi.map(lambda y: (y[0], y[1], y[2], y[3]))
print(golovi.collect())

utakmice = sc.textFile("utakmice.csv").map(lambda x: x.split(';'))
utakmice = utakmice.map(lambda arr: [conv(x) for x in arr])
utakmice = utakmice.map(lambda y: (y[0], y[1], y[2], y[3]))
print(utakmice.collect())

sezone = sc.textFile("sezona.csv").map(lambda x: x.split(';'))
sezone = sezone.map(lambda arr: [conv(x) for x in arr])
sezone = sezone.map(lambda y: (y[0], y[1]))
print(sezone.collect())

####

utakmice_golovi = utakmice.join(golovi)
print("utakmice_golovi", utakmice_golovi.collect())

