from pyspark import SparkConf,SparkContext
import datetime
import csv
import StringIO

def loadRecord(line):
  """Parse a CSV line"""
  input = StringIO.StringIO(line)
  reader = csv.DictReader(input, fieldnames=["name", "favouriteAnimal"])
  return reader.next()

def getYears(idTima,idIgraca,date1, date2):
	
	d1=datetime.strptime(date1,"%d.%m.%Y")
	d2=datetime.strptime(date2,"%d.%m.%Y")
	
	for i in range(d1.year,d2.year):
		yield (i,(idTima,idIgraca))
		
def getBest(paroviIgraca):
	best=0
	for pair in paroviIgraca:
		if(best<pair[1]):
			best=pair[1]
	for pair in paroviIgraca:
		if(best==pair[1])
			return pair
			
def getBest2(paroviIgraca):
	best=0
	igraci=[]
	for pair in paroviIgraca:
		if(best<pair[1]):
			best=pair[1]
	for pair in paroviIgraca:
		if(best==pair[1])
			igraci+=[pair]
	return igraci

#input = sc.textFile(inputFile).map(loadRecord)

conf=SparkConf()
ugovoriRDD=sc.textFile("ugovori.csv").map(loadRecord)
sezoneRDD=sc.textFile("sezona.csv").map(loadRecord).map(lambda x:(x[1],x[0]))
goloviRDD=sc.textFile("golovi.csv").map(loadRecord).map(lambda x: (x[1],(x[2],x[3])))
utakmiceRDD=sc.textFile("utakmice.csv").map(loadRecord).map(lambda x: (x[0],x[1]))
igraciRDD=sc.textFile("igraci.csv").map(loadRecord)

obrada=ugovoriRDD.map(lambda x:getYears(x[1],x[2],x[3],x[4]))
#  (godina, idTima,idIgraca)
obrada=obrada.join(sezoneRDD)
# (godina,((idTima,idIgraca),idSezone))
obrada2=goloviRDD.join(utakmiceRDD)
# (idUtakmice,((idTima,idIgraca),idSezone))
obrada2=obrada2.map(lambda x: ((x[1][0][0],x[1][0][1],x[1][1]),1)).reduceByKey(lambda x,y:x+y)
# ((idTima,idIgraca,idSezone),brojGolova)
obrada2=obrada2.map(lambda x: ((x[0][0],x[0][2]),(x[0][1],x[1]))
# ((idTima,idSezone),(idIgraca,brojGolova))
obrada2=obrada2.reduceByKey(lambda x,y: x+y)
# ((idTima,idSezone),((idIgraca,brojGolova),(...),(....)...))
obrada2=obrada2.mapValues(lambda x: getBest(x))
# ((idTima,idSezone),(najboljiIgrac,brojGolova))
obrada2=obrada2.map(lambda x: (x[1][0],1)).reduceByKey(lambda x,y:x+y)
# (igrac,brojTitula)
najbolji=getBest2(obrada2.collect())
sc.parallelize(najbolji).saveAsTextFile("izlaz.txt")











