from pyspark import SparkConf,SparkContext
from datetime import datetime
import csv

def convertCsvToRdd(fileName):
    return sc.textFile(fileName).mapPartitions(lambda x:csv.reader(x,delimiter=";"))

conf = SparkConf().setMaster("local").setAppName("Utakmice")
sc = SparkContext(conf=conf)

goloviRdd = convertCsvToRdd("golovi.csv")
igraciRdd = convertCsvToRdd("igraci.csv")
sezonaRdd = convertCsvToRdd("sezona.csv")
timoviRdd = convertCsvToRdd("timovi.csv")
ugovoriRdd = convertCsvToRdd("ugovori.csv")
utakmiceRdd = convertCsvToRdd("utakmice.csv")

golovi = goloviRdd.map(lambda x:(x[1],(x[0],x[2],x[3])))
igraci = igraciRdd.map(lambda x:(x[0],x))
sezona = sezonaRdd.map(lambda x:(x[0],x))
timovi = timoviRdd.map(lambda x:(x[0],x))
ugovori = ugovoriRdd.map(lambda x:(x[2],(x[1],x[3],x[4])))
utakmice = utakmiceRdd.map(lambda x:(x[0],x))

igraciSaUgovorima = igraci.join(ugovori).map(lambda x: (x[0],x[1:]))
utakmiceSaGolovima = utakmice.join(golovi).map(lambda x:(x[0],x[1:]))
sezoneSaUtakmicamaIGolovima = sezona.join(utakmiceSaGolovima.map(lambda x:(x[1][0][0][1],x)))
#igraciSaUgovorimaISezonamaSaSvimUtakmicamaIGolovima = igraciSaUgovorima.join(sezoneSaUtakmicamaIGolovima.map(lambda x:(x[1][1][1][1][2],x))) 
#('1', (['1', '2018'], ('1', ((['1', '1', '1', '2'], ('1', '1', '1')),))))

#('1', ((['1', '1', '1', '2'], ('1', '1', '1')),))

#('2', ('1', '1.1.2016', '1.1.2019') - ugovor
#('1', ['1', 'Nemanja Matic']) - igrac
#('11', ((['11', 'Dijego A. Maradona'], ('4', '1.1.2016', '1.1.2019')),)) - join



print(sezoneSaUtakmicamaIGolovima.first())

with open("rezultat.csv","w") as f:
    for line in sezoneSaUtakmicamaIGolovima.collect():
        f.write(line[0] + "\n")
