from pyspark import SparkConf, SparkContext
from datetime import datetime
import csv

def toRDD(csv):
    return sc.textFile(csv).map(lambda x: x.split(';'))

def toCSV(rdd):
    return ','.join(str(data) for data in rdd)

def toDateYear(date):
    return datetime.strptime(date, "%d.%M.%Y").date().year

def doWork():
    # idIgraca, (ime)
    igraciRDD = toRDD("igraci.csv").map(lambda x: (
        int(x[0]),
        (
            x[1]
        )
    ))#.partitionBy(4).persistant

    # idIgraca, (tim, godina1, godina2)
    ugovoriRDD = toRDD("ugovori.csv").map(lambda x: (
        int(x[2]),
        (
            int(x[1]),
            int(toDateYear(x[3])),
            int(toDateYear(x[4]))
        )
    ))

    # idIgraca, (ime, (tim, godina1, godina2))
    igraciUgovoriRDDJoin = igraciRDD.join(ugovoriRDD)

    # idUtakmice, (idSezone, idTim1, idTim2)
    utakmiceRDD = toRDD("utakmice.csv").map(lambda x: (
        int(x[0]),
        (
            int(x[1]),
            int(x[2]),
            int(x[3])
        )
    ))

    # idUtakmice, (idIgraca)
    goloviRDD = toRDD("golovi.csv").map(lambda x: (
        int(x[1]),
        (
            int(x[3])
        )
    ))

    # idUtakmice, ((idSezone, idTim1, idTim2), idIgraca)
    utakmiceGoloviRDDJoin = utakmiceRDD.join(goloviRDD)

    # (idIgraca, idSezone), (idUtakmice)
    utakmiceGoloviRDDClean = utakmiceGoloviRDDJoin.map(lambda x: (
        (
            int(x[1][1]),
            int(x[1][0][0])
        ),
        (
            int(x[0])
        )
    ))
    print(utakmiceGoloviRDDClean.collect())

    # (idIgraca, idSezone), brojGolovaPoSezoni
    igraciSezoneGoloviRDDMax = sc.parallelize(utakmiceGoloviRDDClean.countByKey().items())

    #igraciSezoneGoloviRDDOrder = igraciSezoneGoloviRDDMax.orderByKey(ascending=False)
    #igraciSezoneGoloviRDDClean = igraciSezoneGoloviRDDOrder.map(lambda x: (
    #   int(x[0][0]),
    #   (
    #       int(x[0][1]),
    #       int(x[1])
    #   )   
    # ))
    # igraciSezoneGoloviRDDJoin = igraciSezoneGoloviRDDClean.join(igraciRDD)

    print(igraciSezoneGoloviRDDMax.collect())



    # ISPIS U CSV
    finalRDD = igraciSezoneGoloviRDDMax
    lines = toCSV(finalRDD.collect())
    # lines.saveAsTextFile("igraci.csv")

if __name__ == "__main__":
    conf = SparkConf().setMaster("local").setAppName("Spark")
    sc = SparkContext(conf = conf)

    doWork()