from pyspark import SparkContext, SparkConf
import sys, os
from time import time
import datetime as dt

conf = SparkConf().setMaster("local").setAppName("MyApp")
sc = SparkContext(conf = conf)

if not os.path.exists("izlaz"):
    os.mkdir("izlaz")

igraci = sc.textFile("Ulaz/igraci.csv").map(lambda x: x.split(';')).map(lambda x: (x[2], [x[1], x[3], x[4]]))


#spoj utakmice i zameni id_sezone sa godinom

utakmice = sc.textFile("Ulaz/utakmice.csv").map(lambda x: x.split(';')).map(lambda x: (x[1], [x[0], x[2], x[3]]))
sezona = sc.textFile("Ulaz/sezona.csv").map(lambda x: x.split(';')).map(lambda x: (x[0], x[1]))

#(id_sez, (val1, val2))
utakmice = utakmice.join(sezona).map(lambda x: (x[1][0][0], [x[1][1], x[1][0][1], x[1][0][2]])) #(id_utakmice, [godina_sezone, id_dom, id_gosta])

#spoj sa golovina po id_utakmice
golovi = sc.textFile("Ulaz/golovi.csv").map(lambda x: x.split(';')).map(lambda x: (x[1], [x[3], x[2]])) #(id_utak, [id_igraca, id_tima])

igraci_golovi = golovi.join(utakmice).map(lambda x: (x[1][0][0], [x[1][0][1], x[1][1][1], x[1][1][2], x[1][1][0]])) #id_igraca, [id_tima, id_dom, id_gosta, god_sezone]

ugovori = sc.textFile("Ulaz/ugovori.csv").map(lambda x: x.split(';')).map(lambda x: (x[2], [x[1], x[3], x[4]])) #id_igraca, ostalo


def filter(x):
    if (x[1][0] != x[1][1] and x[1][0] != x[1][2]):
        return False
    date1 = strptime(x[1][1][1])
    date2 = strptime(x[1][1][2])
    date_sezone = strptime(x[1][1][3]) #ispravka
    if date_sezone >= date1 and date_sezone >= date2:
        return True
    

igraci_golovi_ugovori = igraci_golovi.join(ugovori).filter(filter)

#izvrsni = igraci_golovi_ugovori.reduceByKey(lambda x, y: x + y)



igraci_golovi_ugovori.saveAsTextFile("izlaz/" + str(time()))

#igrac(i) koji je najvise puta dao najvise golova u sezoni
