from pyspark import SparkConf, SparkContext

def readCSV(file):
    return sc.textFile(file).map(lambda x: x.split(";"))

def task():

    #idIgraca - ime
    igraci = readCSV("igraci.csv")

    #idIgraca - idUtakmice
    golovi = readCSV("golovi.csv").map(lambda x : ( (x[3]) , (x[1])))

    #idUtakmice - ime
    goloviIgraci = igraci.join(golovi).map(lambda x : ((x[1][1]), (x[1][0])))



    #idUtakmice - idSezone
    utakmice = readCSV("utakmice.csv").map(lambda x: ( (x[0]), (x[1]) ))

    #idUtakmice - (ime, sezona)
    utakmiceSezoneIgraci = goloviIgraci.join(utakmice)

    #(igrac-sezona) - 1 gol (vrednost za sabiranje)
    countingJoin = utakmiceSezoneIgraci.map(lambda x: ((x[1][0],x[1][1]), 1))

    #igrac-sezona - brojGolova
    brGolovaPoSezoniZaIgraca = countingJoin.reduceByKey(lambda x,y: x + y)

    #restructure po sezoni - sezona - (igrac - brGolova)
    brGolovaPoSezoniZaIgraca = brGolovaPoSezoniZaIgraca.map(lambda x :( (x[0][1]) , (x[0][0],x[1])))

    #reduce by key po sezoni : sezona - igrac brGolova da se odabere najbolji za sezonu
    brGolovaPoSezoniZaIgraca = brGolovaPoSezoniZaIgraca.reduceByKey(lambda x,y: (x[0] if max(x[1],y[1]) == x[1] else y[0], max(x[1],y[1])))

    #sada igraca stavimo da bude kljuc, i saberemo sa reduceByKey
    #Igrac - (brGolova, brTitula) 
    brGolovaPoSezoniZaIgraca = brGolovaPoSezoniZaIgraca.map(lambda x: ((x[1][0]), (x[0],x[1][1], 1)))
    brGolovaPoSezoniZaIgraca = brGolovaPoSezoniZaIgraca.reduceByKey(lambda x,y : (x[0] + y[0], x[1] + y[1]))

    #povucemo maks titula
    maxTitula = brGolovaPoSezoniZaIgraca.max(lambda x: x[1][2])[1][2]
    #print(maxTitula)

    #filter za svaki manji od max
    brGolovaPoSezoniZaIgraca = brGolovaPoSezoniZaIgraca.filter(lambda x: x[1][2] < maxTitula)

    brGolovaPoSezoniZaIgraca.saveAsTextFile("izlaz.txt")

    # for line in brGolovaPoSezoniZaIgraca.collect():
    #     print(line)

    



if __name__ == "__main__":
    conf = SparkConf().setMaster("local").setAppName("igraci")
    sc = SparkContext(conf = conf)

    task()
    pass
