from pyspark import SparkConf, SparkContext
import StringIO
import csv


conf = SparkConf().setMaster("local").setAppName("strelci")
sc = SparkContext(conf=conf)

def loadRecord(path):
    csvRDD = sc.textFile(path).mapPartitions(lambda x: csv.reader(x, delimiter=';'))
    return csvRDD

igraci = loadRecord('./igraci.csv')

golovi = loadRecord('./golovi.csv')


utakmice = loadRecord('./utakmice.csv')


sezona = loadRecord('./sezona.csv')


utakmice_golovi = utakmice.map(lambda x: (x[0], x)).join(golovi.map(lambda x: (x[1], x)))

utakmice_sezona = utakmice_golovi.map(lambda x: (x[1][0][1], x)).join(sezona.map(lambda x: (x[0], x)))
#print(utakmice_sezona.first()[1][0][1][1][3])
igrac_golova = utakmice_sezona.map(lambda x: ((x[1][0][1][1][3], x[1][1]), 1))
igrac_golova_uk = igrac_golova.reduceByKey(lambda x, y: x + y)

max_igrac = igrac_golova_uk.map(lambda x: max(x))
igrac_name = max_igrac.map(lambda x: (x[0]][0])).join(igraci.map(lambda x: (x[0], x)))

print(igrac_golova_uk.first())


rdd.saveAsTextFile('./izlaz.txt')