from pyspark import SparkConf, SparkContext
import csv

conf = SparkConf().setMaster("local").setAppName("zadatak")
sc = SparkContext(conf = conf)

# U CSV FAJLOVIMA ; ZAMENJENO ZA ,

def readCSV(x):
    return sc.textFile(x).mapPartitions(lambda x: csv.reader(x))

def getYear(x):
    return x.split('.')[2]


sezone = readCSV("sezona.csv").map(lambda x: (x[0], x[1]))
utakmice = readCSV("utakmice.csv").map(lambda x: (x[1], [x[0], x[2], x[3]]))

igraci = readCSV("igraci.csv").map(lambda x: (x[0], x[1]))
golovi = readCSV("golovi.csv").map(lambda x: (x[3], [x[1], x[2]]))  
ugovori = readCSV("ugovori.csv").map(lambda x: (x[2], [x[1], x[3], x[4]]))

utakmicePoSezoni = sezone.join(utakmice) #(id_sezone, [godina, [id_utakmice, id_domacina, id_gosta]])
igraciUgovoriGolovi = igraci.join(golovi).join(ugovori) #(id_igraca, [ime, [id_utakmice, id_tima], [id_tima, datum1, datum2]])

igraciUgovoriGolovi.filter(lambda x: x[1][1][1] == x[1][2][0])

utakmicePoSezoni.map(lambda x: (x[1][1][0], [x[0], x[1][0], x[1][1][1], x[1][1][2]])) #(id_utakmice, [godina, id_sezone, id_domacina, id_gosta]])
igraciUgovoriGolovi.map(lambda x: (x[1][1][0], [x[0], x[1][0], x[1][1][1], x[1][2][0], getYear(x[1][2][1]), getYear(x[1][2][2])])) #(id_utakmice, [ime, id_igraca, id_tima, id_tima, datum1, datum2]])

sve = utakmicePoSezoni.join(igraciUgovoriGolovi) #(id_utakmice, [[godina, id_sezone, id_domacina, id_gosta], [ime, id_igraca, id_tima, id_tima, datum1, datum2]] ])

sve.filter(lambda x: x[1][0][0] > x[1][1][4] & x[1][0][0] < x[1][1][5]) # godina u intervalu ugovora
sve.filter(lambda x: x[1][0][2] == x[1][1][2] & x[1][0][3] == x[1][1][2]) # filter po timu

igraciSezone = sve.map(lambda x: ([x[1][1][1], x[1][0][1]], 1)) # ([id_igraca, id_sezone], brPonavljanja)
igraciSezone.reduceByKey(lambda x,y: x+y)

# print(sezone.collect())
# print(utakmice.collect())
# print(golovi.collect())
# print(igraci.collect())
print(sve.collect())