from pyspark import SparkConf, SparkContext
import csv
import StringIO
from datetime import datetime

def loadRecord(line):
  """Parse a CSV line"""
  input = StringIO.StringIO(line)
  reader = csv.DictReader(input, fieldnames=["name", "favouriteAnimal"])
  return reader.next()

input = sc.textFile(inputFile).map(loadRecord)


csvRDD = sc.textFile("dept_emp.csv").mapPartitions(lambda x: csv.reader(x))
deptEmp = csvRDD.map(lambda (empt_no, dept_no, from_date, to_date): (empt_no + " " + dept_no, (datetime.strptime(from_date, "%Y-%M-%d").date(), datetime.strptime(to_date, "%Y-%M-%d").date()))).partitionBy(4).cache()


golovi = sc.textFile("golovi.csv").map(lambda line: line.split(";"))
golovi = golovi.map(lambda line: line[1], line[3]) # stavljam kljuc id_utakmica i izuzimam kolone koje nisu potrebne
utakmice = sc.textFile("utakmice.csv").map(lambda line: line.split())
utakmice = utakmice.map(lambda line: line[0], line[1]) # ostavljam samo 2 kolone
igraci = sc.textFile("igraci.csv").map(lambda line: line.split())
igraci = igraci.map(lambda line: (line, 1)).partitionBy(100).persist()


joined = golovi.join(utakmice).map(lambda line: line[1], line[2], 1) # kljuc igrac_id
postignuti_golovi = joined.join(igraci).map(lambda line: line[0], line[2]).reduceByKey(lambda x, y: x + y)

saveAsTextFile("izlaz.txt")