from pyspark import SparkConf, SparkContext
import csv
from datetime import datetime

# spark-submit pokreni.py 
# NAPOMENA: u csv fajlovima ; zamenjeno sa ,

conf = SparkConf().setMaster("local").setAppName("utakmice")
sc = SparkContext(conf = conf)

def readCsvFile(fileName):
    return sc.textFile(fileName).mapPartitions(lambda x: csv.reader(x))

def igraoTeSezone(x):
    # Kreiraj datume iz stringova
    #('2', (('Aleksandar Mitrovic', ('2', '1', '1.1.2016', '1.1.2019')), '2019'))
    datum1 = datetime.strptime(x[1][0][1][2], "%Y-%M-%d").date()
    datum2 = datetime.strptime(x[1][0][1][3], "%Y-%M-%d").date()

    godinaSezone = x[1][1]

    # Uzmi godine pocetnog i krajnjeg datuma
    datum1Year = datum1.year
    datum2Year = datum2.year

    if datum1Year >= godinaSezone:
        if datum2Year <= godinaSezone:
            return True
    return False


igraci = readCsvFile("igraci.csv").map(lambda x: (x[0], x[1]))   # idigraca -> ime
golovi = readCsvFile("golovi.csv").map(lambda x: (x[3], (x[0], x[1], x[2]))) # idigraca ->
sezone = readCsvFile("sezona.csv").map(lambda x: (x[0], x[1]))  # idsezone -> godina
ugovori = readCsvFile("ugovori.csv").map(lambda x: (x[2], (x[0], x[1], x[3], x[4]))) # id_igraca -> sve
utakmice = readCsvFile("utakmice.csv").map(lambda x: (x[0], (x[1], x[2], x[3]))) #id ->
timovi = readCsvFile("timovi.csv").map(lambda x: (x[0], x[1]))  # idtima -> naziv

print(igraci.collect())
print(golovi.collect())
print(sezone.collect())
print(ugovori.collect())
print(utakmice.collect())
print(timovi.collect())

# sezona - golovi
# igrac - brojgolovausezoni
# max

igraciUgovor = igraci.join(ugovori)
igraciSezone = igraciUgovor.join(sezone).filter(igraoTeSezone)
print(igraciSezone.collect())

sezonaIUtakmica = sezone.join(utakmice)

igracUtakmica = igraci.join(utakmice).filter()

